## ⚡ Getting started :

Now we are going to create our Schema and the Database itself.

So, as you know a database Schema is the databse model and the schema of 
how you want your database to look, what information you want to store 
and all and that.

**PainlessDB has 2 types of type to store data, one is `Group` and the other 
is `Static`.**

### 🍞 Group Type
So you use `Group` type when you want to add `content or data` to specific 
group, so you can make a whole list of it. One example of `Group` type is 
**Users**, So you might want to create a database where you can store 
User's account data, and you will have multiple users, and all those will 
be under Users group, kinda like this 
`Users: [user_1, user_2, user_3, user_4...]`. 

### 🌮 Static Type
And you use `Static` type when your data is static like, you have a 
field where you just update the value, you don't create an instance 
or add content like `Group` type, one example of `Static` type is 
`user_count`, so you create a field where  you just update the value of 
user_count + 1 when someone creates a new account and a new user gets 
added, kidna like this `user_count=20`, all you want to do is ust update 
the data. This is what Static type is.


### 🥨 Let's Create Our Database Schema :
We just use plain python dictionary to build `Schema` and that makes it 
really simple and easy.

```python
from painlessdb import Schema

schema = {
    "users": {
        'username': Schema.types.text(),
        'password': Schema.types.text(),
        'is_active': Schema.types.bool(default=True)
    },
    
    "donations": {
        'username': Schema.types.text(),
        'amount': Schema.types.int(),
        'made_when': Schema.types.datetime()
    },
    
    "user_count": Schema.types.int()
}
```

This is our Database Schema and DataTypes(`Schema.types`).
start off, we have a group type `users` where we have 3 fields 
`username | type 'text'`, `password | type 'text'`, `is_active | type 'bool'` 
, another Group type `donations` with `username`, `amount`, `made_when` 
which is a datetime type, and finally a **Static** type which is 
`user_count | type 'int'`. 

### 🥐 Supported Datatypes :
* String :`Schema.types.text()`
* Integer : `schema.types.int()`
* Float : `Schema.types.float()`
* Boolean : `Schema.types.bool()`
* List : `Schema.types.list()`
* Dict : `Schema.types.dict()`
* Datetime: `Schema.types,datetime()`

You can also pass default value in them, like `schema.types.int(default=10)`, this default value will be used in 
database when you don't pass the value.

###

[<b> Database Operations > </b>](3.DatabaseOperations.md)

[<b> < Introduction </b>](1.Introduction.md)
